#include <tap.h>

TAP_ID( 0x8100fe99 );
#define TAPNAME "Test"
TAP_PROGRAM_NAME(TAPNAME);
TAP_AUTHOR_NAME("R2-D2");
TAP_DESCRIPTION("Test TAP");
TAP_ETCINFO(__DATE__);

char *strs[] XDATA = {
	"  ! \" # $ % & ' ( ) * + , - . /",
	"0 1 2 3 4 5 6 7 8 9 : ; < = > ?",
	"@ A B C D E F G H I J K L M N O",
	"P Q R S T U V W X Y Z [ \\ ] ^ _",
	"` a b c d e f g h i j k l m n o",
	"p q r s t u v w x y z { | } ~ ",
	"               ",
	"               ",
	"               ",
	"               ",
	"               ",
	"               "
};

#define NUMSTRS (sizeof(strs)/sizeof(char*))

#define YSTART	(78)
#define YINC	(22)

int DoExit = 0;
word rgn = 0;
int font = 0;

void install()
{
	rgn = TAP_Osd_Create( 0, 0, 720, 576, 0, OSD_Flag_Plane2);
}

void draw(int f)
{
	int i, y = YSTART;
	char s[80];
	TAP_SPrint(s,"Font %d  ('0' for next, 'Exit' to quit)",f);
	TAP_Osd_PutString(rgn, 200, y, 500, s, COLOR_DarkBlue, COLOR_DarkYellow, 0, FNT_Size_1622, 1);
	y += YINC;
	for(i = 0; i < NUMSTRS; i++)
	{
		TAP_Osd_PutString(rgn, 200, y, 500, strs[i], COLOR_White, COLOR_Gray, f, FNT_Size_1622, 1);
		y += YINC;
	}
	TAP_SPrint(s,
		"\x91[%d]Black \x91[%d]Red \x91[%d]Green \x91[%d]Blue \x91[%d]White \x91[%d]None",
		   COLOR_Black,  COLOR_Red,  COLOR_Green,  COLOR_Blue,  COLOR_White,  COLOR_None+1);
	TAP_Osd_PutString(rgn, 200, y, 500, s, COLOR_DarkBlue, COLOR_DarkYellow, 0, FNT_Size_1622, 1);
	y += YINC;
}

void remove()
{
	if(rgn)
		TAP_Osd_Delete(rgn);
}

dword TAP_EventHandler( word event, dword param1, dword param2 )
{
	if(event == EVT_IDLE)
	{
		if(DoExit)
		{
			TAP_Print("Exiting...\n");
			remove();
			TAP_Exit();
		}
	}
	else if(event == EVT_KEY)
	{
		if(param1 == RKEY_0)
		{
			font++;
			if(font>=15)
				font = 0;
			draw(font);
		}
		else if(param1 == RKEY_Exit)
			DoExit = 1;
	}
	return param1;
}

/*****************************************************************************/
/* TAP_main */
/*****************************************************************************/

int TAP_Main(void)
{
	TAP_Print("Installing...\n");
	install();
	draw(font);
	return 1;
}
